/* VClient.java- gets the message,hash it,send the hash to the VServer
 *               gets the public key and the signature from the VServer
 *               sends the public key,hash and signature to V2Server
 *               for verify
 *Vera Arsova, Samuel White 2004
 *********************************************************************/
import org.logi.crypto.*;
import org.logi.crypto.keys.*;
import org.logi.crypto.modes.*;
import org.logi.crypto.protocols.*;
import org.logi.crypto.io.*;

import java.util.Random;
import java.security.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.Object;
import java.lang.*;
import java.security.spec.*;
import java.math.*;
import java.security.KeyPair;

import javax.crypto.*;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.spec.*;

public class VClient {
   
    long seed; 
    
    
    static Random rand = new Random();
    public static void main(String[] args) throws Exception {

	InetAddress serverHost;
        Socket vSocket = null;
	Socket v2Socket = null;
	DatagramPacket dataPacket = null;
        PrintWriter out = null;
	PrintWriter out2=null;
        BufferedReader in = null;
	BufferedReader in2 = null;
	//for the second server
	try {
            v2Socket = new Socket("perryville", 5555);
            out2 = new PrintWriter(v2Socket.getOutputStream(), true);
            in2 = new BufferedReader(new InputStreamReader(v2Socket.getInputStream()));
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: perryville.");
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection to: ringgold");
            System.exit(1);
        }

        BufferedReader stdIn2 = new BufferedReader(new InputStreamReader(System.in));
        String fromServer2;
	//for the first server
        try {
            vSocket = new Socket("perryville", 4444);
            out = new PrintWriter(vSocket.getOutputStream(), true);
	    //oout = new PrintWriter(vSocket.getByteArrayOutputStream(),true);
            in = new BufferedReader(new InputStreamReader(vSocket.getInputStream()));
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: allatoona.");
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection to: yorktown.");
            System.exit(1);
        }

	//the datagramSocket for the first server(ali treba ustvari ova od prviot da se prati na vtorio server.. public#
	//DatagramSocket socket = new DatagramSocket();
	InetAddress adresce = InetAddress.getByName("perryville");
	//System.out.println("the adresce is " + adresce);

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        String fromServer;
        String fromUser;
	try {
	    // Create a secure random number generator
	    SecureRandom sr = SecureRandom.getInstance("SHA1PRNG");
	    
	    // Get 1024 random bits
	    byte[] bytes = new byte[1024/8];
	    sr.nextBytes(bytes);
	    
	    // Create two secure number generators with the same seed
	    int seedByteCount = 10;
	    byte[] seed = sr.generateSeed(seedByteCount);
    
	    sr = SecureRandom.getInstance("SHA1PRNG");
	    System.out.println("this the sr before seeded "+sr);
 	    sr.setSeed(seed);
	    SecureRandom sr2 = SecureRandom.getInstance("SHA1PRNG");
	    sr2.setSeed(seed);
	    System.out.println("this is the sr "+sr+" and the sr2" + sr2);
	}catch (NoSuchAlgorithmException e) {
	    System.out.println("this is the exeption");
	}
	DatagramSocket socket = new DatagramSocket();
	//InetAddress adresce = InetAddress.getByName("wilderness");
	//DatagramPacket packet = new DatagramPacket(buf,buf.lenght,adresce,5555);
	//socket.send(packet);
	   
	/********************
        *
	* THE RANDOM 
	*********************/
	int n = rand.nextInt();
	if (n <= 0 ) n= n*(-1);
	System.out.println(" the Random # is : " + n);
	
	/*****************
         *
         * the username & password 
         * send to the first server
         **************************/
	System.out.print("Username: ");
	String username = stdIn.readLine();
	out.println("verify the username");
	out.println(username);
	System.out.print("Password: ");
	String password = stdIn.readLine();
	int sizePass = password.length();
	
	/*********************
	*
	* THE HASHING SHA1
	*********************/
	System.out.println("Please enter the message! ");
	byte[] digest = new byte[20];
	try{
	    MessageDigest md = MessageDigest.getInstance("SHA");
	    //System.out.println("the md " + md);
	    String data = stdIn.readLine();
	    out2.println("this is the messsage: " + data);
	    md.update(data.getBytes());
	    digest = md.digest();
	    int d = digest.length;
	    System.out.println("the length of the hash is " + d + "the hash is " + digest);
	    DatagramPacket packet = new DatagramPacket(digest,digest.length,adresce,4444);
	    socket.send(packet);
	    System.out.println("The hashed message looks like this : ");
	    for (int i=0; i<digest.length; i++) {
		String hex = Integer.toHexString(digest[i]);
		if (hex.length() == 1) hex = "0" + hex;
		hex=hex.substring(hex.length()-2);
		System.out.print(hex);
		out.print(hex);
	    }
	    }catch (NoSuchAlgorithmException e){}
	String t = " ";
	out.println(t);
	System.out.println(t);
	System.out.println("WAIT for the key and the signature");
	t = in.readLine();
	System.out.println("VServer vika : "+ t); 
	
	/****************************************
         *
         *geting the public key from the server
         ****************************************/
	byte[] publicKeyBytes = new byte[162];
	try {
	    DatagramPacket packet2 = new DatagramPacket(publicKeyBytes,publicKeyBytes.length);
	    socket.receive(packet2);
	    byte[] reseved = new byte[10];
	    reseved = packet2.getData();
	    publicKeyBytes = packet2.getData();
	    System.out.println("the public key is " + publicKeyBytes);
	}catch (IOException e){
	    System.out.println("nemoze jabi ga" );}

	System.out.println("WAIT for Blind Signature from the server");
	
	/**************************************
         *
         * get the signature from the server
         **************************************/
	byte[] sign = new byte[162];
	try {
	    DatagramPacket packetSign = new DatagramPacket(sign,sign.length);
	    socket.receive(packetSign);
	    byte[] reseved = new byte[162];
	    reseved = packetSign.getData();
	    sign = packetSign.getData();
	    System.out.println("the signature is "+sign);
	}catch (IOException e){
	    System.out.println("nemoze jabi ga" );}
	
	/***************************************************************
	 *
         *send the public key,the hash and the signature to the 2server 
         ***************************************************************/ 
	DatagramSocket socket2 = new DatagramSocket();
	DatagramPacket packetKey = new DatagramPacket(publicKeyBytes,publicKeyBytes.length,adresce,5555);
	socket2.send(packetKey);
	DatagramPacket packetSign = new DatagramPacket(sign,sign.length,adresce,5555);
	socket2.send(packetSign);
	DatagramPacket packetHash = new DatagramPacket(digest,digest.length,adresce,5555);
	socket2.send(packetHash);
       

        out.close();
        in.close();
        stdIn.close();
        vSocket.close();
	socket.close();
    }
}
